unit Question2UMemo;
  {*** Solution for main unit of question 2 ***}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus,
  uQuest2Memo;   //*** Change to match the class unit filename. ***

type
  TfrmQ2 = class(TForm)
    mnuMain: TMainMenu;
    mnuOptionA: TMenuItem;
    mnuQuit: TMenuItem;
    redQ2: TRichEdit;
    mnuOptionB: TMenuItem;
    procedure mnuQuitClick(Sender: TObject);
    procedure mnuOptionBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuOptionAClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQ2: TfrmQ2; 

implementation

var
  EnclosuresArr :array[1..30] of TQuest2;
  iCount :integer;

{$R *.dfm}
{$R+}

procedure TfrmQ2.FormCreate(Sender: TObject);
var
   TFile : TextFile;
   iPos, iNumber : integer;
   rSize :real;
   cCat  :Char;
   sLine, sAnimal :String;
begin
   if FileExists ('DataQ2.txt') <> true    then
     begin
       ShowMessage('File does not exist');
       Exit;
     end;
   AssignFile(TFile, 'DataQ2.txt');
   Reset(TFile);

   iCount := 0;
   while (not EOF(TFile) ) do
   begin
     inc(iCount);
     readln(TFile, sLine);
     iPos := pos(';', sLine);
     sAnimal := copy(sLine, 1, iPos -1);
     delete(sLine, 1, iPos);

     iPos := pos('#', sLine);
     iNumber := StrToInt(copy(sLine, 1, iPos -1));
     delete(sLine, 1, iPos);

     iPos := pos(';', sLine);
     rSize := StrToFloat(copy(sLine, 1, iPos -1));
     delete(sLine, 1, iPos);

     cCat := sLine[1];

     EnclosuresArr[iCount] := TQuest2.create(sAnimal, iNumber, rSize, cCat);
   end;
   closeFile(TFile);
end;

procedure TfrmQ2.mnuOptionAClick(Sender: TObject);
var
 K :integer;
begin
     redQ2.Lines.Add('List of all Enclosures');
     redQ2.Lines.Add('====================');
     For K := 1 to iCount do
       begin
          redQ2.Lines.Add('Enclosure number: ' + IntToStr(K) + #13 +
                                     EnclosuresArr[K].toString);
     end;
end;

procedure TfrmQ2.mnuOptionBClick(Sender: TObject);
var
  K,iNum :integer;
  bFound :boolean;
  cCat   :char;
  sAType :String;
begin
  sAType := InputBox('Animal type', 'Enter the type of animal','Tiger');
  iNum := StrToInt(InputBox('Number of animals', 'Enter the number of animals','2'));
  cCat := InputBox('Category', 'Enter the category (L/M/S)','L')[1];
  bFound := false;
  K := 1;
  While (bFound <> true) and (K <= iCount) do
   begin
    if  EnclosuresArr[K].isSuitable(cCat, iNum)  then
       begin
         EnclosuresArr[K].setAType(sAType);
         EnclosuresArr[K].setCat(cCat);
         EnclosuresArr[K].setNumOfAn(iNum);
         bFound := true;
       end
     else
      inc(K);
    end;
    redQ2.Lines.Clear;
    if NOT(bFound) then
      redQ2.Lines.Add('No suitable enclosure was found')
    else
      begin
         redQ2.Lines.Clear;
         redQ2.Lines.Add('These animals were placed in enclosure number ' + IntToStr(K));
         redQ2.Lines.Add(' ');
         mnuOptionA.Click;
      end;
end;

procedure TfrmQ2.mnuQuitClick(Sender: TObject);
begin
  Application.Terminate;
end;

end.
