unit Question3UMEMO;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ComCtrls, Menus;

type
  TfrmQuestion3 = class(TForm)
    MainMenu1: TMainMenu;
    mnuOptionA: TMenuItem;
    mnuOptionB: TMenuItem;
    mnuOptionC: TMenuItem;
    mnuQuit: TMenuItem;
    redQ3: TRichEdit;
    procedure mnuOptionAClick(Sender: TObject);
    procedure mnuQuitClick(Sender: TObject);
    procedure mnuOptionBClick(Sender: TObject);
    procedure mnuOptionCClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion3: TfrmQuestion3;

  arrTic : Array[1..32] of string = ('RCm158', 'ADM33', 'RCf250', 'RAf5',
  'BRM32', 'ADm236',  'RCm23', 'RDM54','RCf17', 'RAm12', 'ADm9', 'RCF43',
  'RDm140', 'RDm23', 'ACF113', 'ABf30', 'RDm22', 'ARf38', 'RCF8', 'RAf53',
  'RCf12', 'ABF156', 'ADM31', 'ADM47', 'RAf48', 'ABF246', 'ABf59', 'RRM321',
  'ABm36', 'RCF31', 'RAm445', 'ACn26');


implementation

{$R *.dfm}
{$R+}

uses Math;

var
  //arrays used in solution for Option C
  arrDisplay : Array[1..8] of string =
                           ('AA','AB','AC','AD','RA','RB','RC','RD');
  arrPoints : Array[1..8] of Integer = (0,0,0,0,0,0,0,0);
  arrMedal  : Array[1..3] of string = ('Gold', 'Silver', 'Bronze');

procedure TfrmQuestion3.FormCreate(Sender: TObject);
begin
   Randomize;
end;

procedure TfrmQuestion3.mnuOptionAClick(Sender: TObject);
var
  A : Integer;
begin
  redQ3.Lines.Clear;
  redQ3.Lines.Add('Invalid entries:');
  For A := 1 to 32 do
   IF (arrTic[A][1] in ['A','R']) AND
      (arrTic[A][2] in ['A'..'D']) AND
      (Upcase(arrTic[a][3]) in ['M','F'])
     then //valid ticket  
     else
         begin //invalid ticket
            redQ3.Lines.Add(arrTic[A]);
            arrTic[A] := 'Z';
         end;
end;

procedure TfrmQuestion3.mnuOptionBClick(Sender: TObject);
var
  iTicket  :integer;
  bValid   :boolean;
begin
 bValid := false;
 iTicket := random(32) + 1;
 while (bValid = false) do
  begin
    if arrTic[iTicket] = 'Z' then
    begin
       bValid := false ;
       redQ3.Lines.Add('Invalid');
       iTicket := random(32) + 1;
    end
    else
       bValid := true;
  end;
  redQ3.Lines.Add('The position of the winning ticket in the array: ' +
                       intToStr(iTicket));
  redQ3.Lines.Add('The winning ticket: '+ arrTic[iTicket] );
end;

procedure TfrmQuestion3.mnuOptionCClick(Sender: TObject);
var
   A, D, iPoint, iTemp  : Integer;
   sTemp                : string;
begin
  //For each display calculate the number of points:
  for D := 1 to 8 do
     arrPoints[D] := 0;

  for D := 1 to 8 do
   begin
     For A := 1 to 32 do
      begin
        IF pos(arrDisplay[D], arrTic[A]) = 1 //only valid tickets <> Z
         then
          begin
             case arrTic[A][3] of
              'm', 'f' : iPoint := 5;
              'M', 'F' : iPoint := 12;
             end;
             inc(arrPoints[D], iPoint);
          end;
      end; //for A.
   end; //for D.

   //Sort the arrays according to points >> ANY SORTING METHOD
  For A := 1 to 8-1 do
    For D := a+1 to 8 do
     IF arrPoints[A] < arrPoints[D]
      then
       begin //swop both displays and ratings arrays!!
         sTemp            := arrDisplay[D];
         arrDisplay[D]    := arrDisplay[A];
         arrDisplay[A]    := sTemp;

         iTemp            := arrPoints[D];
         arrPoints[D]     := arrPoints[A];
         arrPoints[A]     := iTemp;
       end;

  //Display results
  redQ3.Lines.Clear;
  redQ3.Paragraph.TabCount := 2;
  redQ3.Paragraph.Tab[0]   := 80;
  redQ3.Paragraph.Tab[1]   := 150;
  redQ3.Lines.Add('Medal winning displays:');
  redQ3.Lines.Add('Medal' + #9 + 'Display' + #9 + 'Points');
  for A := 1 to 3 do
    redQ3.Lines.Add(arrMedal[A] +#9+ arrDisplay[A] +#9+ Inttostr(arrPoints[A]));
end;

procedure TfrmQuestion3.mnuQuitClick(Sender: TObject);
begin
     Application.Terminate;
end;

end.
